package com.drinkertea.test2smack;

import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import org.jivesoftware.smack.AbstractXMPPConnection;
import org.jivesoftware.smack.chat2.Chat;
import org.jivesoftware.smack.chat2.ChatManager;
import org.jivesoftware.smack.chat2.IncomingChatMessageListener;
import org.jivesoftware.smack.packet.Message;
import org.jxmpp.jid.EntityBareJid;

import java.util.Timer;
import java.util.TimerTask;

public class ChatActivity extends AppCompatActivity {

    TextView tView;
    AbstractXMPPConnection connect = XMPPClass.connection;;
    ChatManager chatManager = XMPPClass.chatManager;;
    LinearLayout chatLayout;
    ScrollView mainScroll;
    EntityBareJid jid;

    {
        try {
            jid = XMPPClass.chatJid;

        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }
    Chat chat = chatManager.chatWith(jid);


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chat);
        try {
            mainScroll = (ScrollView) findViewById(R.id.chatScroll);
            tView = (TextView) findViewById(R.id.testView);
            chatLayout = (LinearLayout) findViewById(R.id.chatLayout);
            createMessageForm();
            mainScroll.fullScroll(ScrollView.FOCUS_DOWN);
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }

    public void sendMessage(View view){
        try {
            String text = tView.getText().toString();
            chat.send(text);
            addMessage(connect.getUser().asBareJid().toString(), text, false);
            tView.setText("");
            mainScroll.fullScroll(ScrollView.FOCUS_DOWN);

        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }

    }

    public void createMessageForm() {
        try {
            XMPPClass.CreateChatListMessage(XMPPClass.chatJid, 15);
            for(Message message : XMPPClass.messages){
                String from = message.getFrom().asBareJid().toString().trim();
                if (from.equals(XMPPClass.myJid.asEntityBareJidString().trim())){
                    addMessage(message.getFrom().asBareJid().toString(), message.getBody(), false);
                }
                else {
                    addMessage(message.getFrom().asBareJid().toString(), message.getBody(), true);
                }
            }
            runMessageListener();
        }catch (Exception e){
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }

    }

    public void runMessageListener(){
        try {
            chatManager.addIncomingListener(new IncomingChatMessageListener() {
                @Override
                public void newIncomingMessage(EntityBareJid from, Message message, Chat chat) {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {

                            try {
                                addMessage(from.asBareJid().toString(), message.getBody(), true);
                                timer.schedule(timerTask, 1, 500);
                                //System.out.println("New message from:" + from + ": " + message.toXML().toString());
                            } catch (Exception e) {
                                //ErrorLogFile.WriterLogs(e.getMessage());
                                System.out.println(e.getMessage());
                            }
                        }
                    });

                }
            });
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }

    public void addMessage(String from, String body, boolean black){
        try {
            TextView fromName = new TextView(this);
            TextView bodyView = new TextView(this);
            LinearLayout linearLayout = new LinearLayout(this);

            fromName.setText(from.split("@")[0] + ": ");
            fromName.setTextSize(16);
            fromName.setTypeface(null, Typeface.BOLD);
            if (black){
                fromName.setTextColor(Color.parseColor("#000000"));
            } else {
                fromName.setTextColor(Color.parseColor("#006000"));
            }

            bodyView.setText(body);
            bodyView.setTextSize(14);
            bodyView.setTextColor(Color.parseColor("#000000"));
            linearLayout.setOrientation(LinearLayout.VERTICAL);
            linearLayout.addView(fromName);
            linearLayout.addView(bodyView);

            chatLayout.addView(linearLayout);
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }
    final Handler handler = new Handler();
    Timer timer = new Timer();
    TimerTask timerTask = new TimerTask() {
        @Override
        public void run() {
            handler.post(new Runnable() {
                @Override
                public void run() {
                    try {
                        mainScroll.fullScroll(ScrollView.FOCUS_DOWN);
                    } catch (Exception e) {
                        //ErrorLogFile.WriterLogs(e.getMessage());
                        System.out.println(e.getMessage());
                    }
                }
            });
        }
    };
}