package com.drinkertea.test2smack;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.viewpager.widget.ViewPager;

import com.drinkertea.test2smack.databinding.ActivityChatsRoomsBinding;
import com.drinkertea.test2smack.ui.main.SectionsPagerAdapter;
import com.google.android.material.tabs.TabLayout;

public class ChatsRooms extends AppCompatActivity {

    private ActivityChatsRoomsBinding binding;

    Handler handler = new Handler();
    Runnable runnable;
    int delay = 7000;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
            handler.postDelayed(runnable = new Runnable() {
                @Override
                public void run() {
                    try {
                        if (XMPPClass.connection.isConnected()){
                            handler.postDelayed(runnable, delay);
                        }
                        else {
                            Toast.makeText(ChatsRooms.this, "Not stable internet connection. Reconnecting...", Toast.LENGTH_LONG).show();
                            XMPPClass.XMPP_Connection(XMPPClass.nickname_local, XMPPClass.pass);
                            if (XMPPClass.connection.isConnected()){
                                reload();
                            }
                            handler.postDelayed(runnable, delay);

                        }
                    }catch (Exception ex){
                        ErrorLogFile.WriterLogs(ex.getMessage());
                    }

                }
            }, delay);
            binding = ActivityChatsRoomsBinding.inflate(getLayoutInflater());
            setContentView(binding.getRoot());
            init();

        } catch (Exception e) {
            //ErrorLogFile.WriterLogs(e.getMessage());
            System.out.println(e.getMessage());
        }
    }
    public void reload(){
        try {
            finish();
            startActivity(new Intent(ChatsRooms.this, ChatsRooms.class));
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
        }

    }
    public void init(){
        try {
            SectionsPagerAdapter sectionsPagerAdapter = new SectionsPagerAdapter(this, getSupportFragmentManager());
            ViewPager viewPager = binding.viewPager;
            viewPager.setAdapter(sectionsPagerAdapter);
            TabLayout tabs = binding.tabs;
            tabs.setupWithViewPager(viewPager);
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
        }

    }
}