package com.drinkertea.test2smack;

import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.GradientDrawable;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.fragment.app.Fragment;

import org.jivesoftware.smackx.muc.MultiUserChat;

import java.util.ArrayList;
import java.util.List;


public class FragmentRooms extends Fragment {

    LinearLayout mainListRooms;
    private View view;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        try {
            view = inflater.inflate(R.layout.fragment_rooms, container, false);
            init();
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
        return view;

    }
    public void init(){
        try {
            mainListRooms = (LinearLayout) view.findViewById(R.id.roomsListLayout);
            GenerateRoomsList();
            XMPPClass.listForMessageListenerMuc.clear();
            XMPPClass.listForMessageListenerMuc.addAll(listForMessageListener());
            getActivity().startService(new Intent(getActivity(), NotificationService.class));
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //e.printStackTrace();
        }
    }
    public List<MultiUserChat> mySortMethod(){
        List<MultiUserChat> sortMuc = new ArrayList<>();
        try {
            for (MultiUserChat sort : XMPPClass.GenerateRoomList()){
                if (sort.isJoined()){
                    sortMuc.add(sort);
                }
            }
            for (MultiUserChat sort : XMPPClass.GenerateRoomList()){
                if (!sort.isJoined()){
                    sortMuc.add(sort);
                }
            }
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
        return sortMuc;
    }
    public List<MultiUserChat> listForMessageListener(){
        List<MultiUserChat> sortMuc = new ArrayList<>();
        try {
            for (MultiUserChat sort : XMPPClass.GenerateRoomList()){
                if (sort.isJoined()){
                    sortMuc.add(sort);
                }
            }
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
        return sortMuc;
    }
    public void GenerateRoomsList(){
        try {
            for (MultiUserChat muc : mySortMethod()){
                LinearLayout Container = new LinearLayout(view.getContext());
                TextView NameRoom = new TextView(view.getContext());
                TextView JIDRoom = new TextView(view.getContext());
                TextView isJoinRoom = new TextView(view.getContext());
                if(muc.isJoined()){
                    isJoinRoom.setText("Connected");
                    isJoinRoom.setTextColor(Color.parseColor("#0081FF"));
                }
                else {
                    isJoinRoom.setText("No access");
                }

                Container.setOrientation(LinearLayout.VERTICAL);

                LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(
                        LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
                layoutParams.height = 195;
                GradientDrawable border = new GradientDrawable();
                border.setColor(Color.parseColor("#ffffff"));
                border.setStroke(5, Color.parseColor("#0081FF"));
                layoutParams.setMargins(55, 15, 55, 15);
                Container.setPadding(15, 15, 15, 15);
                Container.setLayoutParams(layoutParams);
                Container.setBackgroundDrawable(border);
                NameRoom.setTextColor(Color.parseColor("#000000"));
                NameRoom.setText(muc.getRoom().toString().split("@")[0].toUpperCase());

                JIDRoom.setText(muc.getRoom().toString());

                Container.addView(NameRoom);
                Container.addView(JIDRoom);
                Container.addView(isJoinRoom);
                Container.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        if (XMPPClass.connection.isConnected()){
                            XMPPClass.XMPP_JoinRoom(muc.getRoom().asEntityBareJidString(), XMPPClass.nickname_local);
                            Intent intent = new Intent(view.getContext(), Room.class);
                            startActivity(intent);
                        }
                    }
                });

                mainListRooms.addView(Container);
            }
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }

    }

}