package com.drinkertea.test2smack;

import static android.Manifest.permission.READ_EXTERNAL_STORAGE;
import static android.Manifest.permission.RECORD_AUDIO;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

import android.Manifest;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.text.method.HideReturnsTransformationMethod;
import android.text.method.PasswordTransformationMethod;
import android.view.View;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.Toast;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.dcastalia.localappupdate.DownloadApk;


public class MainActivity extends AppCompatActivity {

    private EditText ETemail;
    private EditText ETpassword;
    public SharedPreferences pref;
    public SharedPreferences.Editor editor;
    private Switch switchPass;
    String email;
    String password;
    public static final int REQUEST_AUDIO_PERMISSION_CODE = 200;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
    }
    private void init(){
        try {
            GetPermissionForLogAndDownload();
            pref = getSharedPreferences("login_pass_pref", MODE_PRIVATE);
            ETemail = (EditText) findViewById(R.id.ETEmail);
            ETpassword = (EditText) findViewById(R.id.ETPassword);
            switchPass = (Switch) findViewById(R.id.SwitchBoxPassword);
            ETemail.setText(pref.getString("email", ""));
            XMPPClass.nickname_local = pref.getString("email", "Test From User");
            ETpassword.setText(pref.getString("pass", ""));
            ActivityCompat.requestPermissions(this, new String[]{RECORD_AUDIO, WRITE_EXTERNAL_STORAGE, READ_EXTERNAL_STORAGE}, 1);
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
            //System.out.println(ex.getMessage());
        }
    }
    public void GetPermissionForLogAndDownload(){
        try {
            String[] permissions = {Manifest.permission.WRITE_EXTERNAL_STORAGE,
                    Manifest.permission.INSTALL_PACKAGES,
                    Manifest.permission.REQUEST_INSTALL_PACKAGES};
            if (ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE) ==
                    PackageManager.PERMISSION_DENIED){
                ActivityCompat.requestPermissions(
                        this,
                        permissions,
                        1
                );
            }
        }catch (Exception e){
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }

    public void goToPageWithChats(View view){
        try {
            editor = pref.edit();
            email = ETemail.getText().toString();
            password = ETpassword.getText().toString();
            //Авторизация
            Toast.makeText(this, "Connecting to server...", Toast.LENGTH_SHORT).show();
            boolean isLogin = XMPPClass.XMPP_Connection(email, password);

            //Переход и заупск сервера
            if (isLogin && XMPPClass.connection.getUser() != null){
                editor.putString("email", email);
                editor.putString("pass", password);
                editor.apply();
                Intent intent = new Intent(this, ChatsRooms.class);
                startActivity(intent);
            }
            else {
                Toast.makeText(this, "Connection error!", Toast.LENGTH_LONG).show();
            }
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
            //System.out.println(ex.getMessage());
        }
    }

    public void updateApp(View view){
        try {
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage("Update app?")
                    .setTitle("Information")
                    .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {
                            String[] permissions = {Manifest.permission.WRITE_EXTERNAL_STORAGE,
                                    Manifest.permission.INSTALL_PACKAGES,
                                    Manifest.permission.REQUEST_INSTALL_PACKAGES};
                            if (ContextCompat.checkSelfPermission(MainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE) ==
                                    PackageManager.PERMISSION_GRANTED){
                                    String BASEURL = "https://github.com/WorldOfPets/test_apk_file/raw/master/app-debug.apk";
                                    DownloadApk downloadApk = new DownloadApk(MainActivity.this);
                                    downloadApk.startDownloadingApk(BASEURL);
                            } else {
                                ActivityCompat.requestPermissions(
                                        MainActivity.this,
                                        permissions,
                                        1
                                );
                                String BASEURL = "https://github.com/WorldOfPets/test_apk_file/raw/master/app-debug.apk";
                                DownloadApk downloadApk = new DownloadApk(MainActivity.this);
                                downloadApk.startDownloadingApk(BASEURL);
                            }
                        }
                    })
                    .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {

                        }
                    });
            AlertDialog dialog = builder.create();
            dialog.show();

        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }

    public void showPass(View view) {
        try {
            if(switchPass.isChecked()){
                ETpassword.setTransformationMethod(new HideReturnsTransformationMethod());
            }
            else {
                ETpassword.setTransformationMethod(new PasswordTransformationMethod());
            }
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }
    }

    public void testMethod(View view) {
        try {
            Toast.makeText(this, "Notifications are disabled.", Toast.LENGTH_SHORT).show();
            stopService(new Intent(this, NotificationService.class));
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
        }
    }

    public void sendLogs(View view) {
        try {
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage("Send logs?")
                    .setTitle("Information")
                    .setPositiveButton("Ok", (dialogInterface, i) -> {
                        ErrorLogFile errorLogFile = new ErrorLogFile();
                        errorLogFile.SendLog(ETemail.getText().toString(), ETpassword.getText().toString());
                    })
                    .setNegativeButton("Cancel", (dialogInterface, i) -> {

                    });
            AlertDialog dialog = builder.create();
            dialog.show();
            //ErrorLogFile errorLogFile = new ErrorLogFile();
            //errorLogFile.SendLog(ETemail.getText().toString(), ETpassword.getText().toString());
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
        }

    }

    public void voiceChatActivity(View view) {
        try {
            editor = pref.edit();
            email = ETemail.getText().toString();
            password = ETpassword.getText().toString();
            //Авторизация
            Toast.makeText(this, "Connecting to server...", Toast.LENGTH_SHORT).show();
            boolean isLogin = XMPPClass.XMPP_Connection(email, password);

            //Переход и заупск сервера
            if (isLogin && XMPPClass.connection.getUser() != null){
                editor.putString("email", email);
                editor.putString("pass", password);
                editor.apply();
                Intent intent = new Intent(this, VoiceActivityChat.class);
                startActivity(intent);
            }
            else {
                Toast.makeText(this, "Connection error!", Toast.LENGTH_LONG).show();
            }
        }catch (Exception ex){
            ErrorLogFile.WriterLogs(ex.getMessage());
        }
    }
}
