package com.drinkertea.test2smack;

import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.packet.Message;
import org.jivesoftware.smackx.muc.MultiUserChat;

import java.util.List;

public class Room extends AppCompatActivity {

    public LinearLayout roomLayout;
    public EditText roomMessageET;
    public MultiUserChat thisMuc = XMPPClass.activeMuc;
    private ScrollView mainScroll;

    @Override
    protected void onStart() {
        super.onStart();
        mainScroll.post(new Runnable() {
            @Override
            public void run() {
                mainScroll.fullScroll(ScrollView.FOCUS_DOWN);
            }
        });
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
            setContentView(R.layout.activity_room);
            roomMessageET = (EditText) findViewById(R.id.roomMessageView);
            roomLayout = (LinearLayout) findViewById(R.id.roomLayout);
            mainScroll = (ScrollView) findViewById(R.id.roomScroll);
            List<Message> messages = XMPPClass.CreateRoomListMessage(20, thisMuc);
            for(Message message : messages){
                String from = message.getFrom().asBareJid().toString().trim();
                if (from.equals(XMPPClass.myJid.asEntityBareJidString().trim())){
                    addMessage(message.getFrom().toString().split("/")[1], message.getBody(), false);
                }
                else {
                    addMessage(message.getFrom().toString().split("/")[1], message.getBody(), true);
                }
            }
            runMessageListener();
        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }

    }

    public void addMessage(String from, String body, boolean black){
        try {
            TextView fromName = new TextView(this);
            TextView bodyView = new TextView(this);
            LinearLayout linearLayout = new LinearLayout(this);

            fromName.setText(from + ": ");
            fromName.setTextSize(16);
            fromName.setTypeface(null, Typeface.BOLD);
            if (black){
                fromName.setTextColor(Color.parseColor("#000000"));
            } else {
                fromName.setTextColor(Color.parseColor("#006000"));
            }

            bodyView.setText(body);
            bodyView.setTextSize(14);
            bodyView.setTextColor(Color.parseColor("#000000"));
            linearLayout.setOrientation(LinearLayout.VERTICAL);
            linearLayout.addView(fromName);
            linearLayout.addView(bodyView);

            roomLayout.addView(linearLayout);

        } catch (Exception e) {
            ErrorLogFile.WriterLogs(e.getMessage());
            //System.out.println(e.getMessage());
        }

    }

    public void runMessageListener(){
        try {
            thisMuc.addMessageListener(new MessageListener() {
                @Override
                public void processMessage(Message message) {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            if (message.getBody() != null && message.getBody() != ""){
                                addMessage(message.getFrom().toString().split("/")[1], message.getBody(), true);
                                mainScroll.post(new Runnable() {
                                    @Override
                                    public void run() {
                                        mainScroll.fullScroll(ScrollView.FOCUS_DOWN);
                                    }
                                });
                            }
                        }
                    });
                }
            });
        } catch (Exception e) {
            //ErrorLogFile.WriterLogs(e.getMessage());
            System.out.println(e.getMessage());
        }
    }

    public void sendRoomMessage(View view) {
        try {
            String text = roomMessageET.getText().toString();
            thisMuc.sendMessage(text);
            roomMessageET.setText("");
        }catch (Exception e){
            ErrorLogFile.WriterLogs(e.getMessage());
        }

    }
}